
'Based on ( work by  dan miller, Martin Hebel, Raymond Allen )



CON

  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
  
  ' SHIFTOUT Constants
  LSBFIRST = 0
  MSBFIRST = 1

  ' SHIFTIN Constants
  MSBPRE   = 0
  LSBPRE   = 1
  MSBPOST  = 2
  LSBPOST  = 3
  OnClock  = 4   ' Used for I2C

 'MAX1270 Setup
  DIN   = 25                  ' Set Max1270 DataIn Pin
  DOUT  = 23                  ' Set Max1270 DataOut Pin
  CLK   = 27                  ' Set Max1270 SerialClock Pin
  CS    = 26                  ' Set Max1270 ChipSelect Pin
  'SSTRB = 24

  'Pin Config Out_TOR
  OTOR0 = 8
  OTOR1 = 9

OBJ
    
  ser :         "Extended_FDSerial"    'For debug and serial com

Var

  Long  CogAlarm                'Numro du cog qui gre l'alarme
  Long Alarm_stack[30]
   


PUB get_millivolts(channel, bTenVoltRange, bBipolar):millivolts|controlByte,code
  'get reading and convert to millivolts
  
  'set pin directions
  dira[CLK]~~
  dira[DIN]~~
  dira[CS]~~
  dira[DOUT]~

  'send control byte
  outa[CS]~                           '' signal chip select
  controlByte:=$80 | ((channel&$7)<<4) | ((bTenVoltRange&1)<<3) | ((bBipolar&1)<<2)
  SHIFTOUT(DIN, CLK, controlByte, MSBFIRST, 8) '' put the control bit out
  outa[CS]~~

  'get data                                             
  outa[CS]~ 
  code:=SHIFTIN(DOUT, CLK, MSBPRE,12)         '' data in
  outa[CS]~~
  
  'return voltage
  if bBipolar
    code:=(code<<20)~>19  'sign extend result
  if bTenVoltRange
    millivolts:=(code*10000)~>12  'convert to millivolts
  else
    millivolts:=(code*5000)~>12

  return millivolts

     

     

PUB SHIFTOUT (Dpin, Cpin, Value, Mode, Bits)| bitNum
{{
   Shift data out, master clock, for mode use ObjName#LSBFIRST, #MSBFIRST
   Clock rate is ~16Kbps.  Use at 80MHz only is recommended.
     BS2.SHIFTOUT(5,6,"B",BS2#LSBFIRST,8)
}}
    outa[Dpin]:=0                                          ' Data pin = 0
    dira[Dpin]~~                                           ' Set data as output
    outa[Cpin]:=0
    dira[Cpin]~~

    If Mode == LSBFIRST                                    ' Send LSB first    
       REPEAT Bits
          outa[Dpin] := Value                              ' Set output
          Value := Value >> 1                              ' Shift value right
          !outa[Cpin]                                      ' cycle clock
          !outa[Cpin]
          waitcnt(1000 + cnt)                              ' delay

    elseIf Mode == MSBFIRST                                ' Send MSB first               
       REPEAT Bits                                                                
          outa[Dpin] := Value >> (bits-1)                  ' Set output           
          Value := Value << 1                              ' Shift value right    
          !outa[Cpin]                                      ' cycle clock          
          !outa[Cpin]                                                             
          waitcnt(1000 + cnt)                              ' delay                
    outa[Dpin]~                                            ' Set data to low


PUB SHIFTIN (Dpin, Cpin, Mode, Bits) : Value | InBit
{{
   Shift data in, master clock, for mode use BS2#MSBPRE, #MSBPOST, #LSBPRE, #LSBPOST
   Clock rate is ~16Kbps.  Use at 80MHz only is recommended.
     X := BS2.SHIFTIN(5,6,BS2#MSBPOST,8)
}}
    dira[Dpin]~                                            ' Set data pin to input
    outa[Cpin]:=0                                          ' Set clock low 
    dira[Cpin]~~                                           ' Set clock pin to output 
                                                
    If Mode == MSBPRE                                      ' Mode - MSB, before clock
       Value:=0
       REPEAT Bits                                         ' for number of bits
          InBit:= ina[Dpin]                                ' get bit value
          Value := (Value << 1) + InBit                    ' Add to  value shifted by position
          !outa[Cpin]                                      ' cycle clock
          !outa[Cpin]
          waitcnt(1000 + cnt)                              ' time delay

    elseif Mode == MSBPOST                                 ' Mode - MSB, after clock              
       Value:=0                                                          
       REPEAT Bits                                         ' for number of bits                    
          !outa[Cpin]                                      ' cycle clock                         
          !outa[Cpin]                                         
          InBit:= ina[Dpin]                                ' get bit value                          
          Value := (Value << 1) + InBit                    ' Add to  value shifted by position                                         
          waitcnt(1000 + cnt)                              ' time delay                            
                                                                 
    elseif Mode == LSBPOST                                 ' Mode - LSB, after clock                    
       Value:=0                                                                                         
       REPEAT Bits                                         ' for number of bits                         
          !outa[Cpin]                                      ' cycle clock                          
          !outa[Cpin]                                                                             
          InBit:= ina[Dpin]                                ' get bit value                        
          Value := (InBit << (bits-1)) + (Value >> 1)      ' Add to  value shifted by position    
          waitcnt(1000 + cnt)                              ' time delay                           

    elseif Mode == LSBPRE                                  ' Mode - LSB, before clock             
       Value:=0                                                                                   
       REPEAT Bits                                         ' for number of bits                   
          InBit:= ina[Dpin]                                ' get bit value                        
          Value := (Value >> 1) + (InBit << (bits-1))      ' Add to  value shifted by position    
          !outa[Cpin]                                      ' cycle clock                          
          !outa[Cpin]                                                                             
          waitcnt(1000 + cnt)                              ' time delay

    elseif Mode == OnClock                                            
       Value:=0
       REPEAT Bits                                         ' for number of bits
                                        
          !outa[Cpin]                                      ' cycle clock
          waitcnt(500 + cnt)                               ' get bit value
          InBit:= ina[Dpin]                               ' time delay
          Value := (Value << 1) + InBit                    ' Add to  value shifted by position
          !outa[Cpin]
          waitcnt(500 + cnt)  

PUB StartAlarm(ValAlarmHi,High_Pos,ValAlarmLo,Low_Pos,Latch_Alarm)


CogAlarm:=cognew(Alarm(ValAlarmHi,High_Pos,ValAlarmLo,Low_Pos,Latch_Alarm), @Alarm_stack)+1 

return CogAlarm

PUB Alarm(ValAlarmHi,High_Pos,ValAlarmLo,Low_Pos,Latch_Alarm)| signe,val '
ser.start(31, 30, 0, 9600)
repeat

     
  if(CS)
    val:=get_millivolts(0, 1, 1) ' canal 0  / range : -10 +10
    
    
    ser.dec(val)
    waitcnt(clkfreq*5 +cnt)
    
    if (result>0)
       signe := true
    else
       signe := false

    if(Latch_Alarm)'Alarme Latch
   
      if (result > ValAlarmHi and signe ==  High_Pos)
        HIGH(OTOR1)
             

        
              
      if (result < ValAlarmLo and signe == Low_Pos)
        HIGH(OTOR0)
    else 'Alarme momentane
    
      if (result > ValAlarmHi and signe ==  High_Pos)
        HIGH(OTOR1)
      else
        LOW(OTOR1)
              
      if (result < ValAlarmLo and signe == Low_Pos)
        HIGH(OTOR0)
        LOW(OTOR0)
  else
    waitcnt(clkfreq/1000 + cnt) ' attends 1ms si le max 1270 est occup             
  waitcnt(clkfreq*2 + cnt) 'attend 0,5 secondes entre chaque mesure

PUB StopAlarm
  if CogAlarm
    cogstop(CogAlarm~ -1 )


PUB HIGH(Pin)
    dira[Pin]~~
    outa[Pin]~~
         
PUB LOW(Pin)
    dira[Pin]~~
    outa[Pin]~
 